%include "doc_Arc.i"
%include "doc_Edge.i"
%include "doc_DiGraph.i"
%include "doc_DAG.i"
%include "doc_UndiGraph.i"
%include "doc_CliqueGraph.i"
%include "doc_MixedGraph.i"
%include "doc_PDAG.i"

%include "doc_Variable.i"
%include "doc_DiscreteVariable.i"
%include "doc_LabelizedVariable.i"
%include "doc_DiscretizedVariable.i"
%include "doc_RangeVariable.i"
%include "doc_IntegerVariable.i"
%include "doc_NumericalDiscreteVariable.i"

%include "doc_Instantiation.i"
%include "doc_Tensor.i"

%include "doc_GraphicalModel.i"
%include "doc_DAGmodel.i"
%include "doc_IBayesNet.i"
%include "doc_BayesNet.i"
%include "doc_BayesNetFragment.i"
%include "doc_EssentialGraph.i"
%include "doc_MarkovBlanket.i"
%include "doc_MeekRules.i"

%include "doc_BNdistance.i"
%include "doc_GibbsBNdistance.i"
%include "doc_ExactBNdistance.i"

%include "doc_GenericInference.i"

%include "doc_LazyPropagation.i"
%include "doc_ShaferShenoyInference.i"
%include "doc_VariableElimination.i"

%include "doc_InformationTheory.i"

%include "doc_LoopyBeliefPropagation.i"
%include "doc_GibbsSampling.i"
%include "doc_MonteCarloSampling.i"
%include "doc_WeightedSampling.i"
%include "doc_ImportanceSampling.i"

%include "doc_LoopyGibbsSampling.i"
%include "doc_LoopyMonteCarloSampling.i"
%include "doc_LoopyWeightedSampling.i"
%include "doc_LoopyImportanceSampling.i"

%include "doc_IApproximationSchemeConfiguration.i"
%include "doc_ApproximationScheme.i"

%include "doc_BNDatabaseGenerator.i"
%include "doc_BNLearner.i"

%include "doc_MarkovRandomField.i"
%include "doc_ShaferShenoyMRFInference.i"

%include "doc_PRMexplorer.i"

%include "doc_CredalNet.i"
%include "doc_CNInference.i"
%include "doc_CNMonteCarloSampling.i"
%include "doc_CNLoopyPropagation.i"

%include "doc_InfluenceDiagram.i"
%include "doc_ShaferShenoyLIMIDInference.i"

%include "doc_miscellaneous.i"
%include "doc_JunctionTreeGenerator.i"
%include "doc_IDGenerator.i"
%include "doc_BNGenerator.i"

%include "doc_StructuralComparator.i"

%include "doc_PythonLoadListener.i"
%include "doc_PythonBNListener.i"
%include "doc_PythonApproximationListener.i"

%include "doc_GumException.i"
%include "doc_SyntaxError.i"
/****************************************************************************
 *   This file is part of the aGrUM/pyAgrum library.                        *
 *                                                                          *
 *   Copyright (c) 2005-2025 by                                             *
 *       - Pierre-Henri WUILLEMIN(_at_LIP6)                                 *
 *       - Christophe GONZALES(_at_AMU)                                     *
 *                                                                          *
 *   The aGrUM/pyAgrum library is free software; you can redistribute it    *
 *   and/or modify it under the terms of either :                           *
 *                                                                          *
 *    - the GNU Lesser General Public License as published by               *
 *      the Free Software Foundation, either version 3 of the License,      *
 *      or (at your option) any later version,                              *
 *    - the MIT license (MIT),                                              *
 *    - or both in dual license, as here.                                   *
 *                                                                          *
 *   (see https://agrum.gitlab.io/articles/dual-licenses-lgplv3mit.html)    *
 *                                                                          *
 *   This aGrUM/pyAgrum library is distributed in the hope that it will be  *
 *   useful, but WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,          *
 *   INCLUDING BUT NOT LIMITED TO THE WARRANTIES MERCHANTABILITY or FITNESS *
 *   FOR A PARTICULAR PURPOSE  AND NONINFRINGEMENT. IN NO EVENT SHALL THE   *
 *   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER *
 *   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,        *
 *   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR  *
 *   OTHER DEALINGS IN THE SOFTWARE.                                        *
 *                                                                          *
 *   See the GNU Lesser General Public License (LICENSE.LGPL) and the MIT   *
 *   licence (LICENSE.MIT) for more details.                                *
 *                                                                          *
 *   Contact  : info_at_agrum_dot_org                                       *
 *   homepage : http://agrum.gitlab.io                                      *
 *   gitlab   : https://gitlab.com/agrumery/agrum                           *
 *                                                                          *
 ****************************************************************************/




